GNU bug report logs - #27544
25.1; Visualization of Unicode bidirectional marks

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Itai Berli <itai.berli@HIDDEN>; Done: Lars Ingebrigtsen <larsi@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 2 Dec 2021 09:49:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 02 04:49:50 2021
Received: from localhost ([127.0.0.1]:46645 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msiis-0005wz-Ma
	for submit <at> debbugs.gnu.org; Thu, 02 Dec 2021 04:49:50 -0500
Received: from relay4-d.mail.gandi.net ([217.70.183.196]:39047)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1msiir-0005wl-0U
 for 27544 <at> debbugs.gnu.org; Thu, 02 Dec 2021 04:49:49 -0500
Received: (Authenticated sender: juri@HIDDEN)
 by relay4-d.mail.gandi.net (Postfix) with ESMTPSA id D80ECE0010;
 Thu,  2 Dec 2021 09:49:40 +0000 (UTC)
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
Organization: LINKOV.NET
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
 <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
 <87fsrc8goq.fsf@HIDDEN> <8335ncs0z6.fsf@HIDDEN>
 <87bl20jkg7.fsf@HIDDEN> <83wnkoqki5.fsf@HIDDEN>
Date: Thu, 02 Dec 2021 11:04:07 +0200
In-Reply-To: <83wnkoqki5.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 01 Dec
 2021 19:53:54 +0200")
Message-ID: <865ys7o0q0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>,
 itai.berli@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

>> > Thanks.  But wouldn't glyphless-hex-display-mode be a better name?
>> > glyphless-display-mode doesn't really say what it does to glyphless
>> > characters.
>>
>> It doesn't hexify the glyphs, it uses `acronym'.  But I thought we might
>> allow that to be customised if somebody asks for it, which is why it's
>> not called `glyphless-acronym-display-mode'.
>
> But glyphless-display-mode has no mnemonic value.  We already display
> glyphless characters, so this name doesn't help at all.
>
> Does anyone have suggestions for a better name?

"glyphless-display-mode" looks fine - I read it as to mean
a mode that defines how to display glyphless chars.
It could also provide a defcustom with a choice from
glyphless-char-display-method.

Where I see the problem is that the whole new file was created in
lisp/textmodes/glyphless-mode.el for just glyphless-display-mode,
instead of adding it to lisp/international/characters.el
where this feature is defined with all its functions
glyphless-char-display-control, update-glyphless-char-display,
and more.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 17:54:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 12:54:18 2021
Received: from localhost ([127.0.0.1]:45546 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msToA-0002KW-6h
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 12:54:18 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36826)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1msTo8-0002KK-Lt
 for 27544 <at> debbugs.gnu.org; Wed, 01 Dec 2021 12:54:17 -0500
Received: from [2001:470:142:3::e] (port=33272 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msTo2-0002l8-LJ; Wed, 01 Dec 2021 12:54:11 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=uNZw9KYxJmtoCqQPqlhYuVZ3ixQNBeofnrfqAnSQzD0=; b=nFhOpW4S/KUy
 3tbZGfBq2Ad3a37lUXDR1zBvhs06LCtuIRjBUrSqWPxvQSKeq4W/ukTOEmMNNWtjSWWkGIEdRhGj0
 dLdK2CTFPrivHTUfABumlDhxSdCiBTj5ZvNlfzDsXf7MM1jdXAUjKoI0Mv8SNfZgrmjiDRnVIJ8BR
 Iw6EhgpO+IOYgBt81u0VgxqOAfSs2RyVX0Rv6zOBHNzh94oo3h/drk+6jrfOTXXlwhR0gDr17Bvkk
 mh/ATb5bJzVYwjrA52DzDlm8LUWTPBXjCjXCisJjXncAy5vuulpOgZcdIXev8bPp/PqKilsQNYPG3
 /i/p1Q/mqP1AJIiROPEs8g==;
Received: from [87.69.77.57] (port=3974 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msTo2-0001lW-DI; Wed, 01 Dec 2021 12:54:10 -0500
Date: Wed, 01 Dec 2021 19:53:54 +0200
Message-Id: <83wnkoqki5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87bl20jkg7.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 01 Dec 2021 18:36:56 +0100)
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
 <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
 <87fsrc8goq.fsf@HIDDEN> <8335ncs0z6.fsf@HIDDEN> <87bl20jkg7.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org, itai.berli@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: itai.berli@HIDDEN,  27544 <at> debbugs.gnu.org
> Date: Wed, 01 Dec 2021 18:36:56 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Thanks.  But wouldn't glyphless-hex-display-mode be a better name?
> > glyphless-display-mode doesn't really say what it does to glyphless
> > characters.
> 
> It doesn't hexify the glyphs, it uses `acronym'.  But I thought we might
> allow that to be customised if somebody asks for it, which is why it's
> not called `glyphless-acronym-display-mode'.

But glyphless-display-mode has no mnemonic value.  We already display
glyphless characters, so this name doesn't help at all.

Does anyone have suggestions for a better name?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 17:37:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 12:37:11 2021
Received: from localhost ([127.0.0.1]:45504 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msTXb-0001qa-F8
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 12:37:11 -0500
Received: from quimby.gnus.org ([95.216.78.240]:56076)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1msTXZ-0001qN-9S
 for 27544 <at> debbugs.gnu.org; Wed, 01 Dec 2021 12:37:10 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=j12Ue4Rt48IYGxNICb0ipi71QoDi1jPlS6PSv/0S6yU=; b=mP75kOotUgyCVtBiy24qr6cEwv
 p00AMpYbSkOfRkXvImc4i209ybgCIVlMwoRF82/f4rOpm8PpBv6BrxTFBw4HpkK+ND3/+nAzdkUYz
 UI5131Fu0sWKbkbMSMFWhK+eXwtQd3dpnGG0DFNguDKiuhJUKKtOZIFmH0nghFYzEHCg=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1msTXP-0001Bu-T3; Wed, 01 Dec 2021 18:37:02 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
 <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
 <87fsrc8goq.fsf@HIDDEN> <8335ncs0z6.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAElBMVEXJyMayr7OWlKBX
 V2P28xr///9HRQ2EAAAAAWJLR0QF+G/pxwAAAAd0SU1FB+UMARAVJ3mIWvoAAAG0SURBVDjLrZPr
 deQwCIWFtwHADRipgYzoYE/6r2kvV35McpJ/y5mxZX1CvFu7RMXMVM+vrb2JgJrhKVbrc88oahJc
 eN1B5H12SuI/C0isS2szYsFOUCqqVhRXrCvdsYsteCMqTeyUEKfReqjIZR+u2dZON8q9S0HpFZey
 vt6EQCsi+w5g25AOpdqjWBpCh+Xe1cqDNw/4yR9UgmoVz51E7AB5WHgxebIrfuCh1geve0v7HqUX
 e97ZvVSYLSGAPj/krVp7hsDJpx4MHu/McD+vKtfX22A7P+qUPxYq9CZb5utLH+hKraK0syokzRY5
 Tq25ZyrbZx3c4mynHJnHA2yfKvQgIVPuQtmKl2HMnMjyfmugA2ox8gBoMp6Oseoqz/zY42iSdCWu
 giK8MbeM9ie/1Xpkz8gJmzeIar8OlyrEGASXEQ+HQskFgl1A7gR9zGZ3w+JAh3WCPphitADOR8cb
 YNSgDLaBEZh3wJzj5QSqZyRRg2P5Gq/uAOw7GudIGXKFeQKgM6UgNWHlVa+ACtTi0uBwcvVMMpLo
 lcX+qnT66o2ouULgYGNN7d4+f5a/v4HP/wj+AQY+Z1k/V1ZPAAAAJXRFWHRkYXRlOmNyZWF0ZQAy
 MDIxLTEyLTAxVDE2OjIxOjM4KzAwOjAwkysLxAAAACV0RVh0ZGF0ZTptb2RpZnkAMjAyMS0xMi0w
 MVQxNjoyMTozOCswMDowMOJ2s3gAAAAASUVORK5CYII=
X-Now-Playing: DJ Rupture's _Curiosity Slowdown_: "Curiosity Slowdown (part 2)"
Date: Wed, 01 Dec 2021 18:36:56 +0100
In-Reply-To: <8335ncs0z6.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 01 Dec
 2021 19:12:45 +0200")
Message-ID: <87bl20jkg7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Thanks. But wouldn't
 glyphless-hex-display-mode be a better name? > glyphless-display-mode doesn't
 really say what it does to glyphless > characters. It doesn't hexify the
 glyphs, it uses `acronym'. But I thought we might allow that to be customised
 if somebody asks for it,
 which is why it's not called `glyphless-acronym-display-mode'.
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org, itai.berli@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

> Thanks.  But wouldn't glyphless-hex-display-mode be a better name?
> glyphless-display-mode doesn't really say what it does to glyphless
> characters.

It doesn't hexify the glyphs, it uses `acronym'.  But I thought we might
allow that to be customised if somebody asks for it, which is why it's
not called `glyphless-acronym-display-mode'.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 17:13:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 12:13:12 2021
Received: from localhost ([127.0.0.1]:45474 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msTAN-0001EL-Sp
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 12:13:12 -0500
Received: from eggs.gnu.org ([209.51.188.92]:51032)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1msTAM-0001E6-HH
 for 27544 <at> debbugs.gnu.org; Wed, 01 Dec 2021 12:13:10 -0500
Received: from [2001:470:142:3::e] (port=59136 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msTAH-0003jJ-B6; Wed, 01 Dec 2021 12:13:05 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=d53274ATWXi8x9rxSUPSZIjvpsuCp+sf1kPB3PXpKU4=; b=NQjLdwlmlqdz
 s6ld7X5oUctJWAx7tZQTtvTihCe7kV5V/VBt3u32FDbwzCtBK/cgmOU3J/U73WFsBydlmPq2cx/zV
 TELAiJqW5gbnVtYqtkFtpyAwrJf2x+BLnUNZuRG75Yx0Si5RuORkWPp/+TEUpyS7+fIIHFMF9eNri
 G0tdCkz06wmWkpO/0qlKjz/bkMRafJkOxvzIlgRe1ucnJTPLpnz1CojcSl4iAcswMeYTEg54LpsHQ
 z4OtDUvtVGs7rgDIjP+ld68+CTFNy7y8+z/5o/nhtvPvq6HE5eX7SHG8aPDgPalkPpw7WmM13VOd3
 nleS4yv6MGMsVlBUOI9AYA==;
Received: from [87.69.77.57] (port=1431 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msTAD-0004bd-2b; Wed, 01 Dec 2021 12:13:04 -0500
Date: Wed, 01 Dec 2021 19:12:45 +0200
Message-Id: <8335ncs0z6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-Reply-To: <87fsrc8goq.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 01 Dec 2021 16:53:41 +0100)
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
 <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN> <87fsrc8goq.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org, itai.berli@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Itai Berli <itai.berli@HIDDEN>,  27544 <at> debbugs.gnu.org
> Date: Wed, 01 Dec 2021 16:53:41 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> >> What would be the best way to implement such a mode?  Change
> >> `glyphless-char-display' buffer-locally?
> >
> > Yes, I think so.
> 
> OK; I've now added this under the name `glyphless-display-mode', and it
> seems to work fine in my test case (which is TUTORIAL.he).

Thanks.  But wouldn't glyphless-hex-display-mode be a better name?
glyphless-display-mode doesn't really say what it does to glyphless
characters.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.
bug marked as fixed in version 29.1, send any further explanations to 27544 <at> debbugs.gnu.org and Itai Berli <itai.berli@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 15:53:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 10:53:54 2021
Received: from localhost ([127.0.0.1]:45225 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msRve-0005E7-47
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 10:53:54 -0500
Received: from quimby.gnus.org ([95.216.78.240]:54522)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1msRvc-0005Dp-J7
 for 27544 <at> debbugs.gnu.org; Wed, 01 Dec 2021 10:53:53 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=Vn90NfOWw0bjMZTd6QoYGVJBSQ2+qRcnCpFWvUyfdkE=; b=fjoR5KXIG7GkL7aejoao9vVPnN
 sQI/O9gvMeW5JGwe6z9kzWOdZSVfLD8pom7wOqwWjOcTXdeuicLTRkGitlycEkmoe7s1MC7c5AXIi
 qPxcp+MOrnJinC1GctZOQX7QYj8nf3ThnDvFT9tPx1DM6lTrZ5t5FJZflJFbIQ8QBiUU=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1msRvR-0000O0-VD; Wed, 01 Dec 2021 16:53:45 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
 <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAAD1BMVEW5uLhbWVmAf34i
 ISD////vkLw8AAAAAWJLR0QEj2jZUQAAAAd0SU1FB+UMAQ8HLm/adsAAAAG1SURBVDjLdZSLkesw
 CEVZvQaMaABwA4vpv7e9oNhRZvI040ThCC4fK0TsrkSDao1+7HB8q8il9CwlIzmyDgCY+8v+w8Mm
 M2PLLNOmL6fBrBYcc1wAMfn2cObDJSLjAMDawBwS4jwJ53newOBPZ/IlAKfEDYZxpo4MYYTCp9sS
 b3CRpCvSNjjwAm4scEEsdWTOE6G7+gXmT/IxSg+5QB92bABi4FFieYFaDVINhFYkfHLUF+x5TeAF
 TMqEImApn2ywFg7KcvgAdYwzZANW2m2GYn4A49tYz3WDTnI7Gd5xkwJgj43UmlCa3WmVoefWIKAx
 FQElwHA6VpmUAF5KZ7RXscobALXTGGboQGCssVIhiayRu3q1TvKusiYYDbRGIfwGiDyr6XBIl6ck
 SoFWPu16t0TuokqWY/OoWaqOfwfktZUWqLQxWKsyMJD5AOZSrT50j3nz6DeDRTrPN1j7Or73uIFI
 x8jJO6EVITvhD49VWZZU7IiePNClt0oI5dcV9h9w+VeAK0rfwGWG27L04tziX1xX8lzZ2i6sBXgH
 v70f/Wez+vwK9Vvvcbz+Vx6ATf3GfcZl1j++RZlXQCgnCwAAACV0RVh0ZGF0ZTpjcmVhdGUAMjAy
 MS0xMi0wMVQxNTowNzo0NiswMDowMCFp3MgAAAAldEVYdGRhdGU6bW9kaWZ5ADIwMjEtMTItMDFU
 MTU6MDc6NDYrMDA6MDBQNGR0AAAAAElFTkSuQmCC
X-Now-Playing: Matmos + Wobbly's _Rogue Pulse: Gravity Collapse (10)_: "Ekoplx"
Date: Wed, 01 Dec 2021 16:53:41 +0100
In-Reply-To: <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN> (Eli Zaretskii's
 message of "Wed, 01 Dec 2021 09:48:58 +0200")
Message-ID: <87fsrc8goq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: >> What would be the
 best way to implement such a mode? Change >> `glyphless-char-display'
 buffer-locally? > > Yes, I think so. OK;
 I've now added this under the name `glyphless-display-mode',
 and it seems to work fine in my test case (which is TUTORIAL.he). 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org, Itai Berli <itai.berli@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Eli Zaretskii <eliz@HIDDEN> writes:

>> What would be the best way to implement such a mode?  Change
>> `glyphless-char-display' buffer-locally?
>
> Yes, I think so.

OK; I've now added this under the name `glyphless-display-mode', and it
seems to work fine in my test case (which is TUTORIAL.he).

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 15:52:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 10:52:08 2021
Received: from localhost ([127.0.0.1]:45208 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msRtp-0005A9-SB
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 10:52:08 -0500
Received: from mx0a-00069f02.pphosted.com ([205.220.165.32]:6594)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1msRtm-00059g-OH
 for 27544 <at> debbugs.gnu.org; Wed, 01 Dec 2021 10:52:00 -0500
Received: from pps.filterd (m0246627.ppops.net [127.0.0.1])
 by mx0b-00069f02.pphosted.com (8.16.1.2/8.16.1.2) with SMTP id 1B1FUBiT017206; 
 Wed, 1 Dec 2021 15:51:57 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=from : to : subject :
 date : message-id : references : in-reply-to : content-type :
 content-transfer-encoding : mime-version; s=corp-2021-07-09;
 bh=ElSKVnbnDI10hJaiJRmuti1dLajjVYNy7xI5hwguOx0=;
 b=DxgWGe+kL1sXncMvB2eczmqMleXKEEdckzwoDfeXk+loVpdmSZBCXGBkhgcyXQlhn6sN
 rEHXyBPt9lW48xltakwDF8Z3aFoc9tdBGAlZYxALY9Py/xTr1Lkq7poIgNpl2650Z+9G
 tZ502INhK8Z6k7Kmyxr6VF6sUrZd0WRxsHYfE8T7TbqUcpZx3sIypQet+9IKINEswgUw
 oMc/Q+1JYJJsgc/uyGbnT0wGdQUp1WYsY3TeGTzxJzut4H4SA699kWrnnM+WSgrU8nFd
 mUG986ykiUAiVBu6iyTzi3CC0SWz/saVLZrzmn7YI7XEFmNtYI9TRGo1te5eQvhX05PP Pw== 
Received: from aserp3030.oracle.com (aserp3030.oracle.com [141.146.126.71])
 by mx0b-00069f02.pphosted.com with ESMTP id 3cp7wehkh3-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Wed, 01 Dec 2021 15:51:56 +0000
Received: from pps.filterd (aserp3030.oracle.com [127.0.0.1])
 by aserp3030.oracle.com (8.16.1.2/8.16.1.2) with SMTP id 1B1FJXmb143236;
 Wed, 1 Dec 2021 15:51:49 GMT
Received: from nam12-bn8-obe.outbound.protection.outlook.com
 (mail-bn8nam12lp2177.outbound.protection.outlook.com [104.47.55.177])
 by aserp3030.oracle.com with ESMTP id 3ckaqgq17b-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Wed, 01 Dec 2021 15:51:49 +0000
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=l7wKWhCaUWtSBm9tlFozX8JR/dU2dxEBadXF84oAbt2Ou+ILRJ8lPG9cRKKdzr19eq3jLt4+xIzth/sKQKZIEZ9Xr4OCdRfSwRulVX8eiETc2RP54szwI8Iish+hmBSifvuY1BaPlmxkLY8AhECxYdHY2MSC9yOc14QMzCdoG9Jxn8zaBSY02WSWhVn1ENQIRtDa/mGLXjmRd805gXJ7HpX5PjgkUkuAqTM8MeRwf9YdvWWfKprb2LlelpN1LVmSlnyB/ojE43AczgpKx3DjgdqLq8oWkBT0MjyEFGCqt4EOFMPCH3IdQ3UIyoVdNNWOChMTndn6LNbicboN5yje1Q==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=ElSKVnbnDI10hJaiJRmuti1dLajjVYNy7xI5hwguOx0=;
 b=MQ+8VLmNmPh1U6N+1YWaS0s1M3CRrdKO/Sx0JozD8EYt7RpiqsPUR8hN5zvA9ula0tw2VQSlkhVaLHdV4QRJL251w5r8oyaeqR3IQvGsGCBbfvCi5MWb2p8SJD3cg9o0Ou91/dlaFBQB0cTH/OybGpU72Q/tzIO+IaT2g2Ti+G6P2daqSc5VBVPX3Tc3kfedh8UzoqHwcujA/OU/TICKagGMpDZVlQtTqtkSm/nCQWBUyT2XBajbj/1HzMxvj02ptTCM7VC7kRRHMJNOtUV+XklJbgjcXLKz4ym2tRScsFh8DkES6uOVLoLNPvdPzdVQqkRgqmTKXE00JyMJFakLbQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=oracle.com; dmarc=pass action=none header.from=oracle.com;
 dkim=pass header.d=oracle.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=oracle.onmicrosoft.com; s=selector2-oracle-onmicrosoft-com;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=ElSKVnbnDI10hJaiJRmuti1dLajjVYNy7xI5hwguOx0=;
 b=apnoIpQQDXOZdH3DXzRZMR1fB7+OXlRByeNnzj+ObJcNlRuy6ACuO7vQh9WoXJ9NNYXvXRBEDjJOZ/CE/XZYngyoz6Qu+hc3K/0l5VanD0uDIk6kNMy3ni8FVNO4aHW05D6+C/jTAIPhs8c+kBIUtOVUklGf6qHClUSBq4fvuV4=
Received: from SJ0PR10MB5488.namprd10.prod.outlook.com (2603:10b6:a03:37e::19)
 by SJ0PR10MB5565.namprd10.prod.outlook.com (2603:10b6:a03:3d8::21)
 with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.4734.23; Wed, 1 Dec
 2021 15:51:47 +0000
Received: from SJ0PR10MB5488.namprd10.prod.outlook.com
 ([fe80::4588:646c:e330:8bc0]) by SJ0PR10MB5488.namprd10.prod.outlook.com
 ([fe80::4588:646c:e330:8bc0%9]) with mapi id 15.20.4734.024; Wed, 1 Dec 2021
 15:51:47 +0000
From: Drew Adams <drew.adams@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, "27544 <at> debbugs.gnu.org"
 <27544 <at> debbugs.gnu.org>, "larsi@HIDDEN" <larsi@HIDDEN>,
 "itai.berli@HIDDEN" <itai.berli@HIDDEN>
Subject: RE: [External] : bug#27544: 25.1; Visualization of Unicode
 bidirectional marks
Thread-Topic: [External] : bug#27544: 25.1; Visualization of Unicode
 bidirectional marks
Thread-Index: AQHX5ogTr/Uve/C5bkOXrlsSZ2F9uawdxzrg
Date: Wed, 1 Dec 2021 15:51:47 +0000
Message-ID: <SJ0PR10MB5488BCD45080E718CF3A0599F3689@HIDDEN>
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN> <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
In-Reply-To: <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
Accept-Language: en-US
Content-Language: en-US
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
x-ms-publictraffictype: Email
x-ms-office365-filtering-correlation-id: eea6c46b-bf7d-4d8b-49f3-08d9b4e27b54
x-ms-traffictypediagnostic: SJ0PR10MB5565:
x-microsoft-antispam-prvs: <SJ0PR10MB55655B1FAB1589A8D3326A62F3689@HIDDEN>
x-ms-oob-tlc-oobclassifiers: OLM:9508;
x-ms-exchange-senderadcheck: 1
x-ms-exchange-antispam-relay: 0
x-microsoft-antispam: BCL:0;
x-microsoft-antispam-message-info: 6y7sEJ86CBkyLT7CoO9pygbhrujyzM6cy4+YZ6lMMC6wacB8KIDevKEj/IeCp/SnkTVZSO77JOjthItFgofQJTZNjU0D5ZciKYOAUXw/LYl+Cce5mPwTFp+a115T/4N/ISVvlSlmqg6+CAWrxRhd8TNAR4qPb2CATIoqqhvRrSTsxDDGlLcgA8WaA7KFZ8a8mtf4oLWFf3SKLZliLvcEA6qXrGL3GlyZWZtMt89Kk/yi+a9mY+mGFlkRjZ6ZfEMAfH9XyjgF6SsWwL4wKHyXFnY1GTspKMOCAcSdECBBv/+j3qyHKcVeM/BJe8yIaQ6/3e0opJ5cvYMfH6BlH2msYBrsPEFXd2T6RH8pagJPIbJxuF1vP/2khwqswt6yP3VKFVVhzwc503wjxaljwPl4/IpvVzBFJAiVQDCTmB1AAUB/MvaeuNZC3HRZfMm4A1OCzqbitwuscL6xTaxdIf6F9Mcrrwiy5aBhWF4bw2LK7kBDFbHvHlnm4auBbQuocgtzQrjdb28GL9H8FxCuWtU3J3JJT/IGFZmCoGOezkWFZPQT+QOPUXow4KIsP0hSpsJaUAG6/hOqT0DvhDFCmfI1KyyMPUUBWT2nuIMDzDadP/u3Ke8knZoMEpBgfNnaPdiEYDtr9AVd2oEQxNtgq/7oRzzWNOMXolw1sEiKbi7euG+s24F+gW44pEif4/8U3e93ZZdVKYXx+HAV02uLqBfvHdK0HfFv/UwMi3dSinc0pobV7gPKaZ4D23+Xjr6v64yvt5QivapI9QEzln1D7u8+b22Iz3GM0icTjrylPLfIQp4=
x-forefront-antispam-report: CIP:255.255.255.255; CTRY:; LANG:en; SCL:1; SRV:;
 IPV:NLI; SFV:NSPM; H:SJ0PR10MB5488.namprd10.prod.outlook.com; PTR:; CAT:NONE;
 SFS:(366004)(7696005)(55016003)(6506007)(66946007)(66556008)(44832011)(76116006)(508600001)(83380400001)(66446008)(64756008)(186003)(52536014)(66476007)(8936002)(26005)(38100700002)(8676002)(71200400001)(122000001)(33656002)(110136005)(966005)(316002)(5660300002)(86362001)(9686003)(2906002)(38070700005);
 DIR:OUT; SFP:1101; 
x-ms-exchange-antispam-messagedata-chunkcount: 1
x-ms-exchange-antispam-messagedata-0: =?utf-8?B?amNocUFBMldYRmM3Rk82dWVCL3lxM2lkTW1Dczh6UFRxYVJVUk1XZjVDSktl?=
 =?utf-8?B?R2FOVjZTTEFzdHdGdEtvRHdOSjRpUEhNWWl5M2R6QmpFVUVFcjRoMFFQQk8x?=
 =?utf-8?B?TFFUOE5Jd25XR2JvUHlqQng2WVgzcmcxUGNVWkV5OW1adGRiUVh2VXVBc25q?=
 =?utf-8?B?VUxDTUMyckk3OUgyYTZRUDB0SzR5Slk0YnRFQWg5VldsRDF2N3ZCMkk2TWtC?=
 =?utf-8?B?a1J4Zkl6NWZpQ0F5K1hPNTc2NnJncnExRUFMV2k0ZS95aGxqaEtMZjlRbk1H?=
 =?utf-8?B?bm9VUUs0R2VZL0Q1NWxOVjZHOHRXcTBySEZXTzFxOGQwc0VDN2E2VWg3YWx5?=
 =?utf-8?B?YnRuNEtzOU5wdHI2Q01pbEQ1REorb0M4REJ0Y3UwREJHeHlIVXI1N21VUXk2?=
 =?utf-8?B?cXVpRVNCdXl6KytPUFJPWHYwQm1UR0hRZEhCT3lWZ1JvZWlLR2xWaXdDL0JH?=
 =?utf-8?B?cjAwS3psckw5dTlYTllrQzRra2RvU1BsZXBITkoxZGRuSUxNUW5Oam9XcjZU?=
 =?utf-8?B?N1RCNzh2VEhMUWlZVUwzTkg1Y1BXc1J1RDRPSWlOeDVqSVJpRksxcVBNd21w?=
 =?utf-8?B?Ny9UckVGS2t0bnJZNitlVi8zcjBYUi9uOVF1U1B6UHVOY3lhRGYvZEliRmNp?=
 =?utf-8?B?K2wvSUMzMlZsQWw3MkxFZ1d0UjNmeUo3UjFoa0I3SytvWG1qSnFGQWx0Tzhj?=
 =?utf-8?B?TkFmNlRzUTVod3duajhLZVM0MU5mdVFKd084RGNtOGtQNmFpMmxnQlo1cU51?=
 =?utf-8?B?YnpJbHUxMGJsL3lKMkZrYXlFUTQ1ZWhZZWtBMDQxbC9UYi9YbUh4NmdWWkww?=
 =?utf-8?B?WWp5b3dHdUxwUERUUFhiOXhvQk82TGdkenhqckhYS2RJZDVCRXR1NlIzS2Qw?=
 =?utf-8?B?Q1hoK2dORW5xSEVHbTNPalBUZk9mMEJhZWZ1bmVVRkVEK1VPM0VGcCt6R3l1?=
 =?utf-8?B?cUw1SHJReEJHQjB1MEo5WTNjRXg0b3FZMUlFMUpTb3huc3BzY09tYTVEUVJ2?=
 =?utf-8?B?T1VCZTBrVjNSSzVGanpPN1hBKzZoUWMwcVVLOG94Q2F0RVB6cW82MEdrYTdZ?=
 =?utf-8?B?SVN5MUJtYkt5RDdFZzJ0ZHpqditlbmpxckl5V0sxYUxLMW9EVmgxRGVBb1Jn?=
 =?utf-8?B?S3ZFNzljK2tpMFl1TW5GenVFQzFuNkNWcm4xUEFhbi9CRjdSQk0wSUpUTW0r?=
 =?utf-8?B?U1dzMFZ1WGREOXRWVDM4SnV6R1k1NHg4eGtJN2h2YjJNNlgzU2VxMUhublZv?=
 =?utf-8?B?NHRrRm03ajAvbVBDRy8rQ2xSdWxZamU2VDVyZ3dScU14dVk1emhuNm5FMHJH?=
 =?utf-8?B?YkJucDBiaTIwcFlpU0w0aGZESkx1am4xbzdQN0Z1b0VyUWFLcXdRdmJlZVlq?=
 =?utf-8?B?aDhZWVdWRU1xZTI5NmcrVXhISTQ0UFJSUHpLZGRycHk4ZnlLWkIzMzNMTS84?=
 =?utf-8?B?aUJQMjNDM2J5Ui9TM2ExdlJOdVBIcGdUUng1RElLb1lLM3dVS3NtbVR0R3hu?=
 =?utf-8?B?WGVhS2pyUmMwOS9EdlZZejdhb2YvYXV6NE9lTlBQYlFWcDh4OS9mb0JTM2Jh?=
 =?utf-8?B?bUNCelFsOXFvem42RVkyTkRIcnhFWTU0aHJuRjRWdHBEWnRPemZkN01iVG5C?=
 =?utf-8?B?dU1LKzkzR0FvZFJLTHU3Mk9xdThpOVNlVVRyZDdSSklGcXBJWGkvd1NWVkxQ?=
 =?utf-8?B?OHdaenhVampDQUNKSVFmMHAvSWszZS9majNzNm5aZGh0Uzk3a05IWFRyZTdW?=
 =?utf-8?B?WUs4U2pDRDgvaVoxeVBmc1Q3Vis3R2lKNTBhcHAzMHNid0Z1c2prRDRiWVJE?=
 =?utf-8?B?NlFQbERMaU9lYVJ3LzV5REppWmlKaVFEMnBENWZqR0ZiQlhSNDdxZ3NiSGQ5?=
 =?utf-8?B?RklkSE5yOUxDK3g5OTQ5Q1hNdXdYMUxQeXN3d09VbnZ1NE1EanhVbFVaKzJW?=
 =?utf-8?B?RjlYOXdFNHBiVEtLNFY0RTVRMHdmRjhqcGJ2MjFQUTkwS051TTQzSDdhbkov?=
 =?utf-8?B?MGdod1p0NFpENHRaUXdDdVVtS3ZyWGhlaVRaNmFORmp6VEI4S1M1ZEVYbWtl?=
 =?utf-8?B?TjRGQVNhanJGUGduUFlmcllKUk5yRURyaTUvOVd2Q0Y4Tkxabk5PRE9nbkFp?=
 =?utf-8?B?eXhqbTdFejQxclBRU0o0ZWFLWnVqTGRZYktseVRkbFVDbUh0TjQrVFRWdmFG?=
 =?utf-8?B?ekE9PQ==?=
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: base64
MIME-Version: 1.0
X-OriginatorOrg: oracle.com
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-AuthSource: SJ0PR10MB5488.namprd10.prod.outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: eea6c46b-bf7d-4d8b-49f3-08d9b4e27b54
X-MS-Exchange-CrossTenant-originalarrivaltime: 01 Dec 2021 15:51:47.3011 (UTC)
X-MS-Exchange-CrossTenant-fromentityheader: Hosted
X-MS-Exchange-CrossTenant-id: 4e2c6054-71cb-48f1-bd6c-3a9705aca71b
X-MS-Exchange-CrossTenant-mailboxtype: HOSTED
X-MS-Exchange-CrossTenant-userprincipalname: HfeXdv0e/nHGWne6D8MxkUIKJCczBs9E9SgCkFZzT8ER62v5ntM6R8z5i800dg4/QCVHRv9roWZJQTwAJFv9uw==
X-MS-Exchange-Transport-CrossTenantHeadersStamped: SJ0PR10MB5565
X-Proofpoint-Virus-Version: vendor=nai engine=6300 definitions=10185
 signatures=668683
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 adultscore=0
 malwarescore=0 mlxscore=0
 suspectscore=0 mlxlogscore=999 spamscore=0 phishscore=0 bulkscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.12.0-2110150000
 definitions=main-2112010087
X-Proofpoint-ORIG-GUID: IlazNsKgorzkjWICy2Mof7nzVMgMbqIo
X-Proofpoint-GUID: IlazNsKgorzkjWICy2Mof7nzVMgMbqIo
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 27544
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

PiA+ID4gRW1hY3Mgc3VwcG9ydHMgMTIgVW5pY29kZSBiaWRpcmVjdGlvbmFsIG1hcmtzIChBTE0s
IFJMTSwgTFJNLCBMUkUsDQo+ID4gPiBSTEUsIExSTywgUkxPLCBQREYsIEZTSSwgTFJJLCBSTEks
IGFuZCBQREkpLCBlYWNoIG9mIHdoaWNoIGRpc3BsYXlzIGFzDQo+ID4gPiBhIHZlcnkgdGhpbiBz
cGFjZS4gVGhpcyByYWlzZXMgdHdvIHByb2JsZW1zLg0KPiA+DQo+ID4gUGVyaGFwcyB0aGVyZSBz
aG91bGQgYmUgYSBtaW5vciBtb2RlIHRvIGRpc3BsYXkgdGhlc2UgY2hhcmFjdGVycyBtb3JlDQo+
ID4gY2xlYXJseSwgYmVjYXVzZSB0aGV5IGNhbiBiZSBwcmV0dHkgY29uZnVzaW5nIHRvIGRlYWwg
d2l0aC4NCj4gPg0KPiA+IFdoYXQgd291bGQgYmUgdGhlIGJlc3Qgd2F5IHRvIGltcGxlbWVudCBz
dWNoIGEgbW9kZT8gIENoYW5nZQ0KPiA+IGBnbHlwaGxlc3MtY2hhci1kaXNwbGF5JyBidWZmZXIt
bG9jYWxseT8NCj4gDQo+IFllcywgSSB0aGluayBzby4NCg0KKE5vdCBmb2xsb3dpbmcgdGhpcyBi
dWcgdGhyZWFkLiAgSWdub3JlIGlmIG5vdCBoZWxwZnVsLikNCg0KV291bGQgc29tZXRoaW5nIGxp
a2Ugd2hhdCdzIGluIGBtb2RlbGluZS1jaGFyLmVsJyBoZWxwPw0KDQpUaGVyZSdzIGEgbWlub3Ig
bW9kZSB0aGF0IHNob3dzLCBpbiB0aGUgbW9kZSBsaW5lLCB0aGUNCmNoYXIgIGFmdGVyIHBvaW50
LCB0b2dldGhlciB3aXRoIGl0cyBoZXggVW5pY29kZSBjb2RlDQpwb2ludC4gIEUuZy4sIGZvciBj
aGFyIGBlJyBpdCBzaG93cyBlPTAwMDA2NS4NCg0KKiBJZiB5b3UgY2xpY2sgYG1vdXNlLTEnIG9u
IHRoZSBsaWdodGVyIHRoZW4gZnVsbA0KICBpbmZvcm1hdGlvbiBhYm91dCB0aGUgY2hhciBpcyBz
aG93biBpbiBgKkhlbHAqJywNCiAgaW5jbHVkaW5nIHRoZSBmb250IGFuZCBmYWNlcyB1c2VkIGZv
ciB0aGUgY2hhci4NCg0KKiBJZiB5b3UgY2xpY2sgYG1vdXNlLTInIG9uIHRoZSBsaWdodGVyIHRo
ZW4gdGhlDQogIGNoYXIgaXMgY29waWVkIHRvIHRoZSBzZWNvbmRhcnkgc2VsZWN0aW9uLg0KDQoq
IElmIHlvdSBjbGljayBgbW91c2UtMycgb24gdGhlIGxpZ2h0ZXIgdGhlbiB0aGUNCiAgY2hhciBp
cyBzaG93biBlbmxhcmdlZCBpbiBhIHRvb2x0aXAuDQoNCmh0dHBzOi8vd3d3LmVtYWNzd2lraS5v
cmcvZW1hY3MvZG93bmxvYWQvbW9kZWxpbmUtY2hhci5lbA0KDQpGb3IgdGhpcyBidWcsIG1heWJl
IHNvbWUgaW5kaWNhdGlvbiBsaWtlIGBGU0knIHdvdWxkDQpoZWxwIC0gaW5zdGVhZCBvZiBvciBp
biBhZGRpdGlvbiB0byB0aGUgY29kZSBwb2ludC4NCg==




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 07:49:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 02:49:21 2021
Received: from localhost ([127.0.0.1]:43164 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msKMi-00076s-QS
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 02:49:21 -0500
Received: from eggs.gnu.org ([209.51.188.92]:38474)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1msKMV-00076H-Gx
 for 27544 <at> debbugs.gnu.org; Wed, 01 Dec 2021 02:49:18 -0500
Received: from [2001:470:142:3::e] (port=39312 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msKMQ-0004Gz-4g; Wed, 01 Dec 2021 02:49:02 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:References:In-Reply-To:Subject:To:From:
 Date; bh=cYlbRkN95HJuULSLXbQG0dM9sQbuE9xRwhMT4sssD+0=; b=H9rhYVZz7URffKhV6pBK
 OkKA+GTfUBOdwU2B4AiEGdBs/PdqJeAl/YNI3XWyCgYkAbt6684tppz1FLem+Mquo0fvE6EUriGjD
 ZS38AsNBe4nSBfHb+siJhL/8W9OsHxEBAePNE/D864iW7Pm07yNo5jRbklx478Y3P9aCu0twCPA99
 2+9ilxjs1+vVti7pjaS6XsLwHg8pgq49ogztcs4+N/q8ub75RcWGyF70fjy+YZok00/Lw50W2TKeZ
 nljQtofHdmSfAv94PKIgWfAFQHqUWacBXhCG6xvBMVNTnnnkW9T1cRcGvClFyJyh1XQHDtnAojwfZ
 X3iS8KfRkEg3Ww==;
Received: from [2a02:14f:1f9:744::b2c:4ad1] (port=50836 helo=[IPv6:::1])
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msKMP-0001Ng-LR; Wed, 01 Dec 2021 02:49:02 -0500
Date: Wed, 01 Dec 2021 09:48:58 +0200
From: Eli Zaretskii <eliz@HIDDEN>
To: bug-gnu-emacs@HIDDEN, Lars Ingebrigtsen <larsi@HIDDEN>,
 Itai Berli <itai.berli@HIDDEN>
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
User-Agent: K-9 Mail for Android
In-Reply-To: <87sfvcapqd.fsf@HIDDEN>
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
Message-ID: <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
 charset=utf-8
Content-Transfer-Encoding: quoted-printable
Autocrypt: addr=eliz@HIDDEN; keydata=
 mQENBF+pf4UBCAC6vjkWLSAsQpe8YIGKLQzNOJx/IjGtCdFF8uzmO5jmME+SD8ROuJN+t5KXVw58
 uzu75EFD0vHTY9e+udJ2gkpuy0NnzkFcbumdLLo2ERKCoSctZZRhzKXI5z5cHxCqW0B2ygHRrRLt
 oNlGID7bAgcgSViT1ptGqTXO7zGVu4Airok7dNzcPtHgns8GlR5YAFX0TvE6oGd0l2VPghNeVJKJ
 OjrbfhoDxl3ucFpqbqMH8z9HTLDOFpz8UaYYUdJMi3xX6vwTZxI2sM2RRVLUpZyllAkSMI4lln1O
 OgazM/62DJUs/rKIHKBnF6h3/qsJUjUYXaAHbrXY26mWllAd536lABEBAAG0I0VsaSBaYXJldHNr
 aWkgKGVsaXopIDxlbGl6QGdudS5vcmc+iQE4BBMBAgAiBQJfqX+FAhsDBgsJCAcDAgYVCAIJCgsE
 FgIDAQIeAQIXgAAKCRCRwSYvAeuNOYUQB/4/iIKKOG45ijNaRoTvmJJZMvj1S07WQxEm7c5SHEeE
 QbLOAxB9vESOV7sLueuN3oqEndtzyYt4x1WTSBmHFF7h5fcCMjBs41siOIp5Sj/xD0Bvaa0IKGCR
 SZ7PAo8Mq3wgajXpTpn9vxE2PmtzA8KdEE0K1+f9pVAfOpUIcCl44rIxLUW352XG0y7iz6c/O6LB
 1deOKMiKFctKO7pBti1dJEm1ImewLH3H8uTbwspLOs3EB8xhsESxmTidnze68HX2jt+2EeMgCdki
 NU+LWbexQZPfIS7+ZmE06ll0v6+Jy7ZdTkCCRypKWTnW7pIFsq/p4kybV8O/kHSV6B4vvQBfuQEN
 BF+pf4UBCACvFrdx/m22lgObypSmSS4TNlNvQnMUorrMmp0U32hv5adt6CKXeMjk05F+GcIfVMrp
 xqMBn4sEUIXWhhogQJa9ZbWEP/HbS8XjMMbz0Q0Siaty9+DSspK/9u2GWKsz3uQzLCexIJtzmXvj
 AVmvoMCAU/F2t038ggygjYLRgyLRNLgbbartu2dMkvrfxRjheip60S4S3utOcwUf/qdoa1grNann
 CFluHr/ftXCeeuGB4H8iO0BXWNby6NZPizxJttx9gdcH8/OmDOJkXyRMTT/3sSem76CSOjfXcz7s
 aJlg680NQhG5TmuYERjJD4+U02K5RuqTsEnOuWeFy4p+/mslABEBAAGJATYEGAECAAkFAl+pf4UC
 GwwAIQkQkcEmLwHrjTkWIQTmyQKcNjrUHXh6jruRwSYvAeuNOejsB/9rVegsfEBSRLjeeYXyJrOf
 dme7BYpYsQCw2vGTnrJTGFQ9HM2zT9+wAENBHWjQPJOptJwo5w4xIbZgwJy0uIN3sV18xbCRSxX0
 ZSk8GJG0PrQTCaf2xs0kqsShnkvqyo5QSyUlFUAG7m1o7NUhF95Q89oxGO8JyvR356kqNbzUn0Cq
 PxKyS42QfC8dyFNgVhVPbZp6aONnUwY5SbtCLJtZCBgvppI9XaBH41BDukSE4GgSLoYsSIGShg4h
 e+bGypAsGtQ9uwmryUi1gRrDgca3wFo/G0rbJn2ZKoLbGFZivWPVgAgd9/O5sLSPFznOdcRGxEA2
 gk7A1ReaJ10PtQz0
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On December 1, 2021 6:55:22 AM GMT+02:00, Lars Ingebrigtsen <larsi@gnus=2Eo=
rg> wrote:
> Itai Berli <itai=2Eberli@gmail=2Ecom> writes:
>=20
> > Emacs supports 12 Unicode bidirectional marks (ALM, RLM, LRM, LRE,
> > RLE, LRO, RLO, PDF, FSI, LRI, RLI, and PDI), each of which displays as
> > a very thin space=2E This raises two problems=2E
>=20
> Perhaps there should be a minor mode to display these characters more
> clearly, because they can be pretty confusing to deal with=2E
>=20
> What would be the best way to implement such a mode?  Change
> `glyphless-char-display' buffer-locally?

Yes, I think so=2E




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 1 Dec 2021 07:49:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 01 02:49:04 2021
Received: from localhost ([127.0.0.1]:43160 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msKMS-00076Q-Gk
	for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 02:49:04 -0500
Received: from lists.gnu.org ([209.51.188.17]:44104)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1msKMR-00076I-1S
 for submit <at> debbugs.gnu.org; Wed, 01 Dec 2021 02:49:03 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39214)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>) id 1msKMQ-0000wu-GQ
 for bug-gnu-emacs@HIDDEN; Wed, 01 Dec 2021 02:49:02 -0500
Received: from [2001:470:142:3::e] (port=39312 helo=fencepost.gnu.org)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msKMQ-0004Gz-4g; Wed, 01 Dec 2021 02:49:02 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-Version:References:In-Reply-To:Subject:To:From:
 Date; bh=cYlbRkN95HJuULSLXbQG0dM9sQbuE9xRwhMT4sssD+0=; b=H9rhYVZz7URffKhV6pBK
 OkKA+GTfUBOdwU2B4AiEGdBs/PdqJeAl/YNI3XWyCgYkAbt6684tppz1FLem+Mquo0fvE6EUriGjD
 ZS38AsNBe4nSBfHb+siJhL/8W9OsHxEBAePNE/D864iW7Pm07yNo5jRbklx478Y3P9aCu0twCPA99
 2+9ilxjs1+vVti7pjaS6XsLwHg8pgq49ogztcs4+N/q8ub75RcWGyF70fjy+YZok00/Lw50W2TKeZ
 nljQtofHdmSfAv94PKIgWfAFQHqUWacBXhCG6xvBMVNTnnnkW9T1cRcGvClFyJyh1XQHDtnAojwfZ
 X3iS8KfRkEg3Ww==;
Received: from [2a02:14f:1f9:744::b2c:4ad1] (port=50836 helo=[IPv6:::1])
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1msKMP-0001Ng-LR; Wed, 01 Dec 2021 02:49:02 -0500
Date: Wed, 01 Dec 2021 09:48:58 +0200
From: Eli Zaretskii <eliz@HIDDEN>
To: bug-gnu-emacs@HIDDEN, Lars Ingebrigtsen <larsi@HIDDEN>,
 Itai Berli <itai.berli@HIDDEN>
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
User-Agent: K-9 Mail for Android
In-Reply-To: <87sfvcapqd.fsf@HIDDEN>
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <87sfvcapqd.fsf@HIDDEN>
Message-ID: <2C04D747-6772-4283-8455-39FEE767F61F@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
 charset=utf-8
Content-Transfer-Encoding: quoted-printable
Autocrypt: addr=eliz@HIDDEN; keydata=
 mQENBF+pf4UBCAC6vjkWLSAsQpe8YIGKLQzNOJx/IjGtCdFF8uzmO5jmME+SD8ROuJN+t5KXVw58
 uzu75EFD0vHTY9e+udJ2gkpuy0NnzkFcbumdLLo2ERKCoSctZZRhzKXI5z5cHxCqW0B2ygHRrRLt
 oNlGID7bAgcgSViT1ptGqTXO7zGVu4Airok7dNzcPtHgns8GlR5YAFX0TvE6oGd0l2VPghNeVJKJ
 OjrbfhoDxl3ucFpqbqMH8z9HTLDOFpz8UaYYUdJMi3xX6vwTZxI2sM2RRVLUpZyllAkSMI4lln1O
 OgazM/62DJUs/rKIHKBnF6h3/qsJUjUYXaAHbrXY26mWllAd536lABEBAAG0I0VsaSBaYXJldHNr
 aWkgKGVsaXopIDxlbGl6QGdudS5vcmc+iQE4BBMBAgAiBQJfqX+FAhsDBgsJCAcDAgYVCAIJCgsE
 FgIDAQIeAQIXgAAKCRCRwSYvAeuNOYUQB/4/iIKKOG45ijNaRoTvmJJZMvj1S07WQxEm7c5SHEeE
 QbLOAxB9vESOV7sLueuN3oqEndtzyYt4x1WTSBmHFF7h5fcCMjBs41siOIp5Sj/xD0Bvaa0IKGCR
 SZ7PAo8Mq3wgajXpTpn9vxE2PmtzA8KdEE0K1+f9pVAfOpUIcCl44rIxLUW352XG0y7iz6c/O6LB
 1deOKMiKFctKO7pBti1dJEm1ImewLH3H8uTbwspLOs3EB8xhsESxmTidnze68HX2jt+2EeMgCdki
 NU+LWbexQZPfIS7+ZmE06ll0v6+Jy7ZdTkCCRypKWTnW7pIFsq/p4kybV8O/kHSV6B4vvQBfuQEN
 BF+pf4UBCACvFrdx/m22lgObypSmSS4TNlNvQnMUorrMmp0U32hv5adt6CKXeMjk05F+GcIfVMrp
 xqMBn4sEUIXWhhogQJa9ZbWEP/HbS8XjMMbz0Q0Siaty9+DSspK/9u2GWKsz3uQzLCexIJtzmXvj
 AVmvoMCAU/F2t038ggygjYLRgyLRNLgbbartu2dMkvrfxRjheip60S4S3utOcwUf/qdoa1grNann
 CFluHr/ftXCeeuGB4H8iO0BXWNby6NZPizxJttx9gdcH8/OmDOJkXyRMTT/3sSem76CSOjfXcz7s
 aJlg680NQhG5TmuYERjJD4+U02K5RuqTsEnOuWeFy4p+/mslABEBAAGJATYEGAECAAkFAl+pf4UC
 GwwAIQkQkcEmLwHrjTkWIQTmyQKcNjrUHXh6jruRwSYvAeuNOejsB/9rVegsfEBSRLjeeYXyJrOf
 dme7BYpYsQCw2vGTnrJTGFQ9HM2zT9+wAENBHWjQPJOptJwo5w4xIbZgwJy0uIN3sV18xbCRSxX0
 ZSk8GJG0PrQTCaf2xs0kqsShnkvqyo5QSyUlFUAG7m1o7NUhF95Q89oxGO8JyvR356kqNbzUn0Cq
 PxKyS42QfC8dyFNgVhVPbZp6aONnUwY5SbtCLJtZCBgvppI9XaBH41BDukSE4GgSLoYsSIGShg4h
 e+bGypAsGtQ9uwmryUi1gRrDgca3wFo/G0rbJn2ZKoLbGFZivWPVgAgd9/O5sLSPFznOdcRGxEA2
 gk7A1ReaJ10PtQz0
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: 27544 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On December 1, 2021 6:55:22 AM GMT+02:00, Lars Ingebrigtsen <larsi@gnus=2Eo=
rg> wrote:
> Itai Berli <itai=2Eberli@gmail=2Ecom> writes:
>=20
> > Emacs supports 12 Unicode bidirectional marks (ALM, RLM, LRM, LRE,
> > RLE, LRO, RLO, PDF, FSI, LRI, RLI, and PDI), each of which displays as
> > a very thin space=2E This raises two problems=2E
>=20
> Perhaps there should be a minor mode to display these characters more
> clearly, because they can be pretty confusing to deal with=2E
>=20
> What would be the best way to implement such a mode?  Change
> `glyphless-char-display' buffer-locally?

Yes, I think so=2E




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Dec 2021 04:55:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Nov 30 23:55:34 2021
Received: from localhost ([127.0.0.1]:43000 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1msHeY-0000Op-Mb
	for submit <at> debbugs.gnu.org; Tue, 30 Nov 2021 23:55:34 -0500
Received: from quimby.gnus.org ([95.216.78.240]:49010)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1msHeW-0000OY-4h
 for 27544 <at> debbugs.gnu.org; Tue, 30 Nov 2021 23:55:32 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=pHHrK/27Zl2UntHYil7L+WbTRxBaMSW7mWbhkAheRfs=; b=XzQ1ENSdHX7uQTB8zugmbpFHMf
 xVT1X/Gmnwuh372+7GAnpquQBASYSerAjh1Mi3zcc8OXgb6pVUZTYs5/zSfBN7WEVtBpPKj6avUDr
 67a3XPc92s/hbZngthziGMY/hGouNl6ZXlvFB1Wuy9m9Swgi7vz7YmzIZAwOiYZ3OLxc=;
Received: from [84.212.220.105] (helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1msHeN-0004Fe-0a; Wed, 01 Dec 2021 05:55:25 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Itai Berli <itai.berli@HIDDEN>
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
X-Now-Playing: Kid606's _Recollected Ambient Works Vol. 1: Bored of
 Excitement_: "G Minor"
Date: Wed, 01 Dec 2021 05:55:22 +0100
In-Reply-To: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 (Itai Berli's message of "Sat, 1 Jul 2017 12:58:28 +0300")
Message-ID: <87sfvcapqd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Itai Berli <itai.berli@HIDDEN> writes: > Emacs supports
 12 Unicode bidirectional marks (ALM, RLM, LRM, LRE, > RLE, LRO, RLO, PDF,
 FSI, LRI, RLI, and PDI), each of which displays as > a very thin space. This
 raises two problems. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Itai Berli <itai.berli@HIDDEN> writes:

> Emacs supports 12 Unicode bidirectional marks (ALM, RLM, LRM, LRE,
> RLE, LRO, RLO, PDF, FSI, LRI, RLI, and PDI), each of which displays as
> a very thin space. This raises two problems.

Perhaps there should be a minor mode to display these characters more
clearly, because they can be pretty confusing to deal with.

What would be the best way to implement such a mode?  Change
`glyphless-char-display' buffer-locally?

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Jul 2017 12:51:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 01 08:51:44 2017
Received: from localhost ([127.0.0.1]:46993 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dRHsF-0001WN-Vz
	for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:51:44 -0400
Received: from eggs.gnu.org ([208.118.235.92]:51829)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1dRHsE-0001WA-C6
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:51:42 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1dRHs4-0002Ry-Aa
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:51:37 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:56403)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1dRHs4-0002Rs-6X; Sat, 01 Jul 2017 08:51:32 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2515
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1dRHs3-00082G-Oi; Sat, 01 Jul 2017 08:51:31 -0400
Date: Sat, 01 Jul 2017 15:51:21 +0300
Message-Id: <83mv8opbg6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Itai Berli <itai.berli@HIDDEN>
In-reply-to: <CABsNJ=MmbxeAq_70i=qGXG8Vqa3JBV27E=KBWcOP5OUZ7yMQAA@HIDDEN>
 (message from Itai Berli on Sat, 1 Jul 2017 15:36:39 +0300)
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <CABsNJ=MmbxeAq_70i=qGXG8Vqa3JBV27E=KBWcOP5OUZ7yMQAA@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -7.8 (-------)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -7.8 (-------)

> From: Itai Berli <itai.berli@HIDDEN>
> Date: Sat, 1 Jul 2017 15:36:39 +0300
> 
> > This is how Emacs behaves, again in line with general Emacs feature of allowing users to see what's in the buffer.
> 
> Except the current display doesn't allow the user to see what's in the buffer.

I think it does: it shows the bidi controls instead of completely
hiding them.

>  > The UBA also allows to retain these characters, including display
> them, see section 5.2 there.
> 
> Well, section 5.2 of the UBA explains:
> 
> > retention of these formatting characters and BNs is important to users who need to display a graphic representation of hidden characters, and who thus need to obtain their visual positions for display.
> 
> Emacs users who need to display a graphic representation of the bidi
> marks are ill-served by the current implementation. And so are those
> who don't need to display a graphic representation of them. The
> current implementation is the worse of both worlds.

Well, I obviously disagree.

In any case, Emacs provides customizations to change the display of
these controls to your liking, and modes which have such needs can do
that in the buffers under the mode.  the Emacs implementation allows
all that.  If we hear enough report from people who would like the
defaults to change, we could consider that in the future.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Jul 2017 12:37:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 01 08:37:27 2017
Received: from localhost ([127.0.0.1]:46979 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dRHeR-0007ow-9r
	for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:37:27 -0400
Received: from mail-ua0-f180.google.com ([209.85.217.180]:34929)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <itai.berli@HIDDEN>) id 1dRHeP-0007oi-Ow
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:37:26 -0400
Received: by mail-ua0-f180.google.com with SMTP id j53so88978813uaa.2
 for <27544 <at> debbugs.gnu.org>; Sat, 01 Jul 2017 05:37:25 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=4gD0COKV+LWHkmS/bb5MzY/fLpOvkv91+fz2CnA/4DI=;
 b=bZw9NXAbhnRb3CxxYY+ItqbK+dnpKp5DXow4pn//Rs11rLFKaz4ezAM82FkIPnMNmP
 CJogssRJ+fZHPZ3OEGWe2tAXajr6SUvGntF31kKmZJwl2dZ9l26Ygj0eTQYGIcTY25iV
 KXGn6Da13EN1qhYn7U7bpDS15YIcMsnY7Izo7ayTznpLCVyY+Z40ViBqnzxu0Db+9wup
 jLn+7mmheugxsHAukevVaikDpZM9azGzEJa5lREEhvFcHTcJvUitISEjAqufCMZYtGQE
 2OfYJYPwOMa/f6lLYrfd2RTrhqg1wUHjSI785kIyHSTVAWCq3f/nx1blB4NV2jBNnDUv
 M48Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=4gD0COKV+LWHkmS/bb5MzY/fLpOvkv91+fz2CnA/4DI=;
 b=r6tcQeXJ2RR7Mh0Sf3HAD8F3BHbfVw2p18kX699DcDh18dGzLOKDNo0VUq971zh++S
 OxVLlLZnqZX1yXqgM8qmWujCVuUG8uURN7HaAptipJmpIRO4HGM2fMl1PoiphdoAcdVU
 tBBzk55JiWFfjoSHdavlUyaWaBJ7XHgEC1lTgpJeMiveUMWYSvbK5/dcS6XKuGCEWFrb
 4uNSV28aI4JMBGPcaqzF/X6knOStF0YgJ3ZL1jt9CiemXFYicEsDtfigncrpTJnEv5rz
 l98Gs5qSJDxG6gY8sRylUTd5eBclcCCL29iR4SD6UHebtshbCw3R9nfz1YO+gqoyd3Do
 PQOQ==
X-Gm-Message-State: AKS2vOwTVwqGwEmy8xKbaQTQOtz0sdHrTxdS4euJLBj8pJhNfZt0eQka
 ka8GP+sBOd1zCJWsObbasd2qEsZjfR5WOWE=
X-Received: by 10.159.32.3 with SMTP id 3mr3731365uam.67.1498912640037; Sat,
 01 Jul 2017 05:37:20 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.176.70.85 with HTTP; Sat, 1 Jul 2017 05:36:39 -0700 (PDT)
From: Itai Berli <itai.berli@HIDDEN>
Date: Sat, 1 Jul 2017 15:36:39 +0300
Message-ID: <CABsNJ=MmbxeAq_70i=qGXG8Vqa3JBV27E=KBWcOP5OUZ7yMQAA@HIDDEN>
Subject: bug#27544: 25.1; Visualization of Unicode bidirectional marks
To: 27544 <at> debbugs.gnu.org
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 27544
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.5 (/)

> This is how Emacs behaves, again in line with general Emacs feature of allowing users to see what's in the buffer.

Except the current display doesn't allow the user to see what's in the buffer.

 > The UBA also allows to retain these characters, including display
them, see section 5.2 there.

Well, section 5.2 of the UBA explains:

> retention of these formatting characters and BNs is important to users who need to display a graphic representation of hidden characters, and who thus need to obtain their visual positions for display.

Emacs users who need to display a graphic representation of the bidi
marks are ill-served by the current implementation. And so are those
who don't need to display a graphic representation of them. The
current implementation is the worse of both worlds.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Jul 2017 12:17:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 01 08:17:12 2017
Received: from localhost ([127.0.0.1]:46974 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dRHKq-0007N1-H2
	for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:17:12 -0400
Received: from eggs.gnu.org ([208.118.235.92]:47152)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1dRHKp-0007Mn-04
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:17:11 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1dRHKg-0004c8-GX
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 08:17:05 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:56203)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1dRHKg-0004c4-Cs; Sat, 01 Jul 2017 08:17:02 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2502
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1dRHKf-0000bo-P1; Sat, 01 Jul 2017 08:17:02 -0400
Date: Sat, 01 Jul 2017 15:16:51 +0300
Message-Id: <83o9t4pd1o.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Itai Berli <itai.berli@HIDDEN>
In-reply-to: <CABsNJ=MX+O08UFZe7ZVCD5KB6w2Tdd=5g-Xe6G+tYHAgw=gq7w@HIDDEN>
 (message from Itai Berli on Sat, 1 Jul 2017 14:48:21 +0300)
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 <CABsNJ=MX+O08UFZe7ZVCD5KB6w2Tdd=5g-Xe6G+tYHAgw=gq7w@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -7.8 (-------)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -7.8 (-------)

> From: Itai Berli <itai.berli@HIDDEN>
> Date: Sat, 1 Jul 2017 14:48:21 +0300
> 
> A default should be something that aligns with the expectations of a
> casual user; you cannot expect a casual user to start writing elisp
> code or tinkering with `glyphless-char-display-control`.
> 
> And how can we know what a casual user would expect?

Thank you for describing your expectations.  However, to change the
defaults, we'd need to hear from more than one user.  If we find that
the majority thinks the default should be changed, we will eventually
do that, as we do with any other default.

> 1. We can follow established standards, particularly if we claim to
> conform to them, as Emacs does to the Unicode standard. The Unicode
> bidi algorithm 8.0.0 specifications state the following about LRM, RLM
> and ALM (section 2.6 Implicit Directional Marks):
> > they do not display or have any other semantic effect
> and again, in the same section:
> >  they do not appear in the display

The UBA also allows to retain these characters, including display
them, see section 5.2 there.  This is how Emacs behaves, again in line
with general Emacs feature of allowing users to see what's in the
buffer.

> 4. We can see how Emacs implements similar constructs. The bidi marks
> are control sequences that can be inserted into the editor using `C-x
> 8 RET <Unicode hex number>`. Let's see how other control sequences are
> handled by this mechanism. If you try to insert, say, the characters
> Null character (U+0000), Bell character (U+0007) and Escape character
> (U+001B) using this method, we'll get:

There are control characters other than those which you tried, for
which Emacs does use the same display method as for bidi controls: try
ZWJ (U+200D) or ARABIC NUMBER SIGN (U+0600) -- all the characters of
Unicode General Category "Cf" that don't have an established graphic
image are by default displayed as thin spaces.  This is explained in
the doc string of glyphless-char-display-control.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Jul 2017 11:49:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 01 07:49:09 2017
Received: from localhost ([127.0.0.1]:46955 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dRGth-0006iX-Dh
	for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 07:49:09 -0400
Received: from mail-vk0-f41.google.com ([209.85.213.41]:35398)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <itai.berli@HIDDEN>) id 1dRGtf-0006iJ-PL
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 07:49:08 -0400
Received: by mail-vk0-f41.google.com with SMTP id 191so77531886vko.2
 for <27544 <at> debbugs.gnu.org>; Sat, 01 Jul 2017 04:49:07 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=7pyTAhnfqY/6kcwGd8vaCnR0jLOYKSwOTc7yBir8+Cg=;
 b=lS23jXB4un07/JXgGOqevKks6eeESQsOi9FUHhMKgIdQJalrlazIVZZnS+A4n1UmQM
 nxp4IXXlntOqappJUSpiIUML7eqKNhyBUvZqF3db7x4FMiJDPw2LE/Taa516JcGRaWv4
 tqIYaYDCfjd3gBd4sfOFke61TtWWaK6iEjmlAtdGwrR6d5CRDp2snt6n2LopEKRoKEew
 4yJtHfBcSrcHtWOmR+bXy5s+B5SIki0djkNOUNTydY5y4XvdKdBK5J8wm6iDXS1Aq9Cs
 OOvH13pqmBztaiDMbHS/cQ4Ik3w64dIq4TLC6OQRrH7ze+a9VGemPoOt9uHvZGs0EDiw
 AnaA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=7pyTAhnfqY/6kcwGd8vaCnR0jLOYKSwOTc7yBir8+Cg=;
 b=IUKZX5NmZULNUVYzYS5KkyqFZzw49YX1NMY/7r+39iBKG+AbLKgc5+aBTgVAoa6SzA
 gOGgtobSwvwVaHw5DsQemA/Z6bTabDUu/CtanCc8KzBQSfwPWLi5fv7rwudA7+PKtibm
 LvPt0TIU9z0qApge3Xc2WOQ0GjGF0POVeblVji6ODtU93ykCb/XcbBeAgT4ofy3AVNVq
 J9uFwvSj/GWW8xRsI95hx+Vv5Kq+FITXXKiylNRrpJcLesuCpbY41UOJTmNLOBFB9Kju
 Z44QTsOAa3WWiBJfo5xa7zNN2zB+h2L/tfJeAgWIw8wruca+CIm4iemWvma75DVM4GrA
 0Mmw==
X-Gm-Message-State: AKS2vOzDfV0LGUgrN2Uy9joEbgmy8GKyaMWBjD0RlhVCFaonDpqDnD49
 jv+gOB46QOZqQBGn3MImG91uKDtkXJICPZA=
X-Received: by 10.31.108.7 with SMTP id h7mr14392662vkc.114.1498909741730;
 Sat, 01 Jul 2017 04:49:01 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.176.70.85 with HTTP; Sat, 1 Jul 2017 04:48:21 -0700 (PDT)
From: Itai Berli <itai.berli@HIDDEN>
Date: Sat, 1 Jul 2017 14:48:21 +0300
Message-ID: <CABsNJ=MX+O08UFZe7ZVCD5KB6w2Tdd=5g-Xe6G+tYHAgw=gq7w@HIDDEN>
Subject: bug#27544: 25.1; Visualization of Unicode bidirectional marks
To: 27544 <at> debbugs.gnu.org
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 27544
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.5 (/)

A default should be something that aligns with the expectations of a
casual user; you cannot expect a casual user to start writing elisp
code or tinkering with `glyphless-char-display-control`.

And how can we know what a casual user would expect?

1. We can follow established standards, particularly if we claim to
conform to them, as Emacs does to the Unicode standard. The Unicode
bidi algorithm 8.0.0 specifications state the following about LRM, RLM
and ALM (section 2.6 Implicit Directional Marks):
> they do not display or have any other semantic effect
and again, in the same section:
>  they do not appear in the display

2. We can see how other text editors behave. The following is a sample
of text editors that are bidi-aware, and none of them displays
explicit bidi marks (they only support RLM and LRM), not even as a
very thing space: Gmail, Google Docs, Libre Writer, MS-Word, Pages,
and TextEdit. By the way, the Unicode bidi algorithm was written by
three editors, two of whom work for Google, and the other one - for
Microsoft, so seeing how Google docs and MS-Word implement
bidirectionally is a good way of seeing how the standard should be
implemented.

3. We can employ common sense. Either the Emacs user will notice the
spaces introduced by the bidi marks, or he won't.

If he does, then it will be visually annoying for him, and will thwart
attempts to realign and position the text precisely.

If he doesn't notice the spaces, then he won't understand, for
instance, why he needs to press the left arrow four times to position
the cursor past the first visible character of a paragraph that begins
with three bidi marks.

In both cases, he won't be able to see the difference between the
various marks, which is a cause for confusion, frustration, and
errors.

4. We can see how Emacs implements similar constructs. The bidi marks
are control sequences that can be inserted into the editor using `C-x
8 RET <Unicode hex number>`. Let's see how other control sequences are
handled by this mechanism. If you try to insert, say, the characters
Null character (U+0000), Bell character (U+0007) and Escape character
(U+001B) using this method, we'll get:

ILLUSTRATION: The characters Null character (U+0000), Bell character
(U+0007) and Escape character (U+001B), in this order.
http://imgur.com/bsJoblk

We see that the output satisfies the three condition I specified in my
original post: (a) Easy to notice, (b) Distinguishable from other
whitespace visualization glyphs, (c) Distinct from one another.

However, in light of to this example I should state that, in my
opinion, unlike other control characters, Emacs should not display the
bidi marks unless in `whitespace` mode. The difference is that control
characters are rarely used by casual writers of alphabetic text,
whereas explicit bidirectional marks are quite commonly used.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at 27544 <at> debbugs.gnu.org:


Received: (at 27544) by debbugs.gnu.org; 1 Jul 2017 10:36:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 01 06:36:47 2017
Received: from localhost ([127.0.0.1]:46939 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dRFlf-0003As-9q
	for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 06:36:47 -0400
Received: from eggs.gnu.org ([208.118.235.92]:34457)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1dRFld-0003Af-ML
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 06:36:45 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <eliz@HIDDEN>) id 1dRFlU-0005E2-Ga
 for 27544 <at> debbugs.gnu.org; Sat, 01 Jul 2017 06:36:40 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RP_MATCHES_RCVD
 autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:55370)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1dRFlU-0005Dw-Cw; Sat, 01 Jul 2017 06:36:36 -0400
Received: from 84.94.185.246.cable.012.net.il ([84.94.185.246]:2461
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1dRFlT-00039b-Lp; Sat, 01 Jul 2017 06:36:36 -0400
Date: Sat, 01 Jul 2017 13:36:24 +0300
Message-Id: <83r2y0php3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Itai Berli <itai.berli@HIDDEN>
In-reply-to: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
 (message from Itai Berli on Sat, 1 Jul 2017 12:58:28 +0300)
Subject: Re: bug#27544: 25.1; Visualization of Unicode bidirectional marks
References: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -7.8 (-------)
X-Debbugs-Envelope-To: 27544
Cc: 27544 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Eli Zaretskii <eliz@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -7.8 (-------)

> From: Itai Berli <itai.berli@HIDDEN>
> Date: Sat, 1 Jul 2017 12:58:28 +0300
> 
> Emacs supports 12 Unicode bidirectional marks (ALM, RLM, LRM, LRE,
> RLE, LRO, RLO, PDF, FSI, LRI, RLI, and PDI), each of which displays as
> a very thin space. This raises two problems.
> 
> 1. On the one hand, the fact that these inherently invisible
> marks manifest, by default, as thin spaces undermines attempts at
> precise alignment and positioning. Moreover, in the case of LRM, RLM
> and ALM, this behavior contradicts explicit directions given in the
> Unicode
> Bidirectional Algorithm 8.0.0 specifications (section 2.6 Implicit
> Directional Marks):
> > they do not appear in the display
> (To my understanding, this is meant to apply to all bidi marks, even
> if only stated explicitly for LRM, RLM and ALM.)
> 
> 2. On the other hand, the fact that these spaces are so thin as to be
> barely noticeable, and the fact that
> they are indistinguishable from one another makes it difficult to debug
> and resolve strange and/or erroneous behavior that can happen in a
> bidi document, an example of which is given below.

The above is the default way these control characters are displayed.
This default was chosen so as to, on the one hand avoid making them
entirely invisible, as doing that was deemed un-Emacsy, and OTOH make
them barely visible, so that they won't disrupt the legibility of the
displayed text.

However, Emacs being Emacs, this is just the default, and it can be
changed.  The visual appearance of these (and other similar)
characters can be customized via the variable
'glyphless-char-display-control', which is described in the Emacs
manual, and in more detail in the ELisp manual.

> The solution to both problems is to make the bidi marks visible in
> `whitespace` mode only, and to give them glyphs that are (a) easy to
> notice, (b) distinguishable from other whitespace visualization glyphs, (c)
> distinct from one another.

You can do that using 'glyphless-char-display-control'.  If that is
somehow not enough, you could also define a display-table entry for
these characters, specifically for whitespace-mode.  Patches to that
effect are welcome (I think this should be a user option, if we want
such a feature).

> If we were able to visualize the whitespace, we would have realized from
> the beginning that the sequence of characters in this paragraph was, from
> left to right:
> 
> RTL-RTL-RLO-RLO-H-e-l-l-o-PDO-,-PDO-SPACE-w-o-r-l-d-!
> 
> Thus, our first three actions removed the first three characters, leaving us
> with:
> 
> RLO-H-e-l-l-o-PDO-,-PDO-SPACE-w-o-r-l-d-!
> 
> We now realize that even the final, correct form, is in fact littered
> with bidi errors and potential landmines!

Overriding the bidi attributes with the likes of RLO can indeed lead
to confusing display.  Emacs has functions that Lisp applications can
use to discover these confusing situations, where the application
would like to warn users.  See the description of
bidi-find-overridden-directionality in the ELisp manual.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 1 Jul 2017 09:59:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 01 05:59:23 2017
Received: from localhost ([127.0.0.1]:46911 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1dRFBT-0002CZ-Cr
	for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 05:59:23 -0400
Received: from eggs.gnu.org ([208.118.235.92]:52878)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <itai.berli@HIDDEN>) id 1dRFBR-0002CJ-Fe
 for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 05:59:21 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <itai.berli@HIDDEN>) id 1dRFBK-0007y3-P3
 for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 05:59:16 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:50815)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <itai.berli@HIDDEN>)
 id 1dRFBK-0007xl-M7
 for submit <at> debbugs.gnu.org; Sat, 01 Jul 2017 05:59:14 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:43835)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <itai.berli@HIDDEN>) id 1dRFBI-00074q-RF
 for bug-gnu-emacs@HIDDEN; Sat, 01 Jul 2017 05:59:14 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <itai.berli@HIDDEN>) id 1dRFBH-0007qE-7f
 for bug-gnu-emacs@HIDDEN; Sat, 01 Jul 2017 05:59:12 -0400
Received: from mail-vk0-x233.google.com ([2607:f8b0:400c:c05::233]:33721)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <itai.berli@HIDDEN>)
 id 1dRFBH-0007m1-1i
 for bug-gnu-emacs@HIDDEN; Sat, 01 Jul 2017 05:59:11 -0400
Received: by mail-vk0-x233.google.com with SMTP id r126so77512027vkg.0
 for <bug-gnu-emacs@HIDDEN>; Sat, 01 Jul 2017 02:59:09 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:from:date:message-id:subject:to;
 bh=hfuw7C5fOF/MCErAUlrKmWnnUGdh4FIihYooESLdk+Y=;
 b=WSpcAsdKvCMhxFGO71LbBAgyzkL0wd90QRd6MqsCXmqBUTvRagbvG2t5HIFPp+UCOW
 BTyt8NfniukGrGxf9Z9Aov0lIfaDHWdDVc0HbuNQsLhOduo7Tafi9lBlep+qFG0l11P/
 wLnjOTGB5xyz08SiI0vquAmn3anDULj0IIyk/D8pBZcvmAuba0rbvgSjRslaIVd/YHa/
 bsnVeqqqnjuAx0/fchQyuo0CUF844KMPZpfMN/TlRncZ373EmK/pQYBSzAtbzRB5P6g5
 aW12qGgfRemXPMV1vLeXHYkeiWOtSOcTX0erwpt+jqArtTFFDbSmOaKb1dyTNzlp+rCQ
 fK+A==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:from:date:message-id:subject:to;
 bh=hfuw7C5fOF/MCErAUlrKmWnnUGdh4FIihYooESLdk+Y=;
 b=WZFr0QAEXyHltQhHVcuDea9RDvSzmvbJPjI0dMlcJG8HsQyhk8NKkVx8xhdmj4vPVB
 WKg+xuBpmjoygJ+w1qf+1q0iktpuzUxKvniSTmBcx2bl2wxC68GQiW1QEGB9S0wRe1Kt
 ypTzX+muRM69vspbRMQ8gl3FV9IaDogWE/YX+eIsLOOql7QA7laEVZf2Bjj8OWGIxgjy
 P1dYErzyvXA7fJZdp+mo2Z/ib3vudSMwee+mQDiBD4ciSHw2GpnJ1R86BZlrgFnhUkbY
 ENN2uSxXHE6g1BcTCXZoD4vIMMG9YiSiNRrxyl8ycNnvVa23EwK9i69IcnuVNgR8DFN/
 yvAw==
X-Gm-Message-State: AKS2vOx74s7R7shhKCtkkWxLfWgJpRD+8//QUrT47kB2TM/NemPDewCw
 TEjM0a1/dNaWwlqJ3xr1jCbVWPguwh3dbd4=
X-Received: by 10.31.138.135 with SMTP id m129mr13150123vkd.84.1498903148603; 
 Sat, 01 Jul 2017 02:59:08 -0700 (PDT)
MIME-Version: 1.0
Received: by 10.176.70.85 with HTTP; Sat, 1 Jul 2017 02:58:28 -0700 (PDT)
From: Itai Berli <itai.berli@HIDDEN>
Date: Sat, 1 Jul 2017 12:58:28 +0300
Message-ID: <CABsNJ=Nb9aie6qfO86ON+0hesfhc2qxVTrUXSRZBcJJcoc7WJA@HIDDEN>
Subject: 25.1; Visualization of Unicode bidirectional marks
To: bug-gnu-emacs@HIDDEN
Content-Type: text/plain; charset="UTF-8"
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -6.8 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.8 (------)

Emacs supports 12 Unicode bidirectional marks (ALM, RLM, LRM, LRE,
RLE, LRO, RLO, PDF, FSI, LRI, RLI, and PDI), each of which displays as
a very thin space. This raises two problems.

1. On the one hand, the fact that these inherently invisible
marks manifest, by default, as thin spaces undermines attempts at
precise alignment and positioning. Moreover, in the case of LRM, RLM
and ALM, this behavior contradicts explicit directions given in the
Unicode
Bidirectional Algorithm 8.0.0 specifications (section 2.6 Implicit
Directional Marks):
> they do not appear in the display
(To my understanding, this is meant to apply to all bidi marks, even
if only stated explicitly for LRM, RLM and ALM.)

2. On the other hand, the fact that these spaces are so thin as to be
barely noticeable, and the fact that
they are indistinguishable from one another makes it difficult to debug
and resolve strange and/or erroneous behavior that can happen in a
bidi document, an example of which is given below.

The solution to both problems is to make the bidi marks visible in
`whitespace` mode only, and to give them glyphs that are (a) easy to
notice, (b) distinguishable from other whitespace visualization glyphs, (c)
distinct from one another.

The following example exhibits strange behavior that can arise due to
the use of bidi marks. This behavior is difficult to debug
without visualizing the bidi marks.

Consider the following paragraph.

ILLUSTRATION #1: An English sentence that is formatted from right to left.
http://imgur.com/is1OBtM

The paragraph is entirely in English, then why is it formatted from right
to left? Without visible bidi marks, it's hard to tell; however a savvy
Unicode-aware person would realize that this must indicate the presence
of a Right-To-Left Mark (U+200F). Therefore, if we position the cursor
at the beginning of the paragraph (`C-a`), and delete the following
character (`C-d`), the sentence should display normally.

ILLUSTRATION #2: Deleting the first Right-To-Left mark at the
beginning of the paragraph has no effect.
http://imgur.com/eBVpdZA

Against our expectations, nothing appears to have changed. There must
be another Right-To-Left mark at the beginning of the paragraph. Let's
delete it as
well. (`C-d`)

ILLUSTRATION #3: Deleting the second Right-To-Left Mark left-aligns
the paragraph, but leave the comma misplaced.
http://imgur.com/Klj3lZC

The paragraph is now aligned to the left, as it should, and everything
looks normal, except for the comma, which appears in the beginning of
the paragraph. But this can be easily remedied: let's delete the comma
and then retype it in its proper place. We position the cursor at the
beginning of the paragraph (`C-a`) and delete the following character (`C-d`).

ILLUSTRATION #4: After trying to delete the comma, the paragraph is
finally displayed correctly.
http://imgur.com/3w73MxM

Instead of deleting the comma, this has shifted the comma to it's
correct position.

If we were able to visualize the whitespace, we would have realized from
the beginning that the sequence of characters in this paragraph was, from
left to right:

RTL-RTL-RLO-RLO-H-e-l-l-o-PDO-,-PDO-SPACE-w-o-r-l-d-!

Thus, our first three actions removed the first three characters, leaving us
with:

RLO-H-e-l-l-o-PDO-,-PDO-SPACE-w-o-r-l-d-!

We now realize that even the final, correct form, is in fact littered
with bidi errors and potential landmines!


In GNU Emacs 25.1.1 (x86_64-apple-darwin13.4.0, NS appkit-1265.21
Version 10.9.5 (Build 13F1911))
 of 2016-09-21 built on builder10-9.porkrind.org
Windowing system distributor 'Apple', version 10.3.1504
Configured using:
 'configure --with-ns '--enable-locallisppath=/Library/Application
 Support/Emacs/${version}/site-lisp:/Library/Application
 Support/Emacs/site-lisp' --with-modules'

Configured features:
NOTIFY ACL GNUTLS LIBXML2 ZLIB TOOLKIT_SCROLL_BARS NS MODULES

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: TeX/P

Minor modes in effect:
  diff-auto-refine-mode: t
  TeX-PDF-mode: t
  ivy-mode: t
  shell-dirtrack-mode: t
  projectile-mode: t
  helm-descbinds-mode: t
  async-bytecomp-package-mode: t
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent messages:
Applying style hooks... done
Mark set
C-> is undefined
Mark set [2 times]
Saving file /Users/itaiberli/Documents/GitHub/Thesis/test22.tex...
Wrote /Users/itaiberli/Documents/GitHub/Thesis/test22.tex
Undo!
Auto-saving...done
repeat-complex-command: There are no previous complex commands to repeat
delete-backward-char: Text is read-only

Load-path shadows:
/Users/itaiberli/.emacs.d/elpa/seq-2.20/seq hides
/Applications/Emacs.app/Contents/Resources/lisp/emacs-lisp/seq

Features:
(shadow sort mail-extr emacsbug message rfc822 mml mml-sec epg mm-decode
mm-bodies mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader
sendmail rfc2047 rfc2045 ietf-drums mail-utils vc-git diff-mode tex-bar
toolbar-x font-latex plain-tex tex-buf latex tex-ispell tex-style tex
crm tex-mode latexenc colir color counsel jka-compr esh-util etags xref
project swiper reftex reftex-vars two-column ivy delsel ivy-overlay
helm-projectile helm-files rx image-dired tramp tramp-compat
tramp-loaddefs trampver shell pcomplete format-spec dired-x dired-aux
ffap helm-tags helm-bookmark helm-adaptive helm-info bookmark pp
helm-external helm-net browse-url xml url url-proxy url-privacy
url-expand url-methods url-history url-cookie url-domsuf url-util
url-parse auth-source gnus-util mm-util help-fns mail-prsvr
password-cache url-vars mailcap helm-buffers helm-grep helm-regexp
helm-utils helm-locate helm-help helm-types projectile grep compile
comint ansi-color ring ibuf-ext ibuffer thingatpt helm-descbinds helm
easy-mmode helm-source cl-seq eieio-compat eieio eieio-core
helm-multi-match helm-lib dired helm-config helm-easymenu cl-macs
async-bytecomp async advice edmacro kmacro finder-inf tex-site info
package epg-config seq byte-opt gv bytecomp byte-compile cl-extra
help-mode easymenu cconv cl-loaddefs pcase cl-lib time-date mule-util
tooltip eldoc electric uniquify ediff-hook vc-hooks lisp-float-type
mwheel ns-win ucs-normalize term/common-win tool-bar dnd fontset image
regexp-opt fringe tabulated-list newcomment elisp-mode lisp-mode
prog-mode register page menu-bar rfn-eshadow timer select scroll-bar
mouse jit-lock font-lock syntax facemenu font-core frame cl-generic cham
georgian utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao
korean japanese eucjp-ms cp51932 hebrew greek romanian slovak czech
european ethiopic indian cyrillic chinese charscript case-table epa-hook
jka-cmpr-hook help simple abbrev minibuffer cl-preloaded nadvice
loaddefs button faces cus-face macroexp files text-properties overlay
sha1 md5 base64 format env code-pages mule custom widget
hashtable-print-readable backquote kqueue cocoa ns multi-tty
make-network-process emacs)

Memory information:
((conses 16 359730 16119)
 (symbols 48 34262 0)
 (miscs 40 100 221)
 (strings 32 65306 15883)
 (string-bytes 1 1997869)
 (vectors 16 60314)
 (vector-slots 8 1721804 214602)
 (floats 8 589 398)
 (intervals 56 269 0)
 (buffers 976 19))




Acknowledgement sent to Itai Berli <itai.berli@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#27544; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Thu, 2 Dec 2021 10:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.